<!DOCTYPE html
  PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
  "DTD/xhtml1-strict.dtd">
<html>
  <head>
    <title>API docs for &ldquo;kiwi.ui.proxy.Proxy&rdquo;</title>
    <meta content="text/html;charset=utf-8" http-equiv="Content-Type" />
    <link href="apidocs.css" type="text/css" rel="stylesheet" />
    
    
  </head>
  <body>
    <h1 class="class">Class k.u.p.Proxy:</h1>
    <p>
      <span id="part">Part of <a href="kiwi.html">kiwi</a>.<a href="kiwi.ui.html">ui</a>.<a href="kiwi.ui.proxy.html">proxy</a></span>
      
      <a href="classIndex.html#kiwi.ui.proxy.Proxy">View In Hierarchy</a>
    </p>
    <div>
      
    </div>
    <div><p>A Proxy is a class that 'attaches' an instance to an interface's 
widgets, and transparently manipulates that instance's attributes as the 
user alters the content of the widgets.</p>
The Proxy takes the widget list and detects what widgets are to be 
attached to the model by looking if it is a KiwiWidget and if it has the 
model-attribute set.
<table class="fieldTable"></table></div>
    
    
    <div id="splitTables">
      <table class="children sortable" id="id300">
  
  
  
  
  <tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.ui.proxy.Proxy.html#__init__">__init__</a></td>
    <td><span>Create a new Proxy object.
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.ui.proxy.Proxy.html#_reset_widget">_reset_widget</a></td>
    <td><span class="undocumented">Undocumented</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.ui.proxy.Proxy.html#_setup_widget">_setup_widget</a></td>
    <td><span class="undocumented">Undocumented</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.ui.proxy.Proxy.html#_register_proxy_in_model">_register_proxy_in_model</a></td>
    <td><span class="undocumented">Undocumented</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.ui.proxy.Proxy.html#_unregister_proxy_in_model">_unregister_proxy_in_model</a></td>
    <td><span class="undocumented">Undocumented</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.ui.proxy.Proxy.html#_on_widget__content_changed">_on_widget__content_changed</a></td>
    <td><span>This is called as soon as the content of one of the widget
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.ui.proxy.Proxy.html#_on_widget__notify">_on_widget__notify</a></td>
    <td><span class="undocumented">Undocumented</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.ui.proxy.Proxy.html#_get_model">_get_model</a></td>
    <td><span class="undocumented">Undocumented</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.ui.proxy.Proxy.html#proxy_updated">proxy_updated</a></td>
    <td><span>This is a hook that is called whenever the proxy updates the
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.ui.proxy.Proxy.html#update_many">update_many</a></td>
    <td><span>Like <a href="kiwi.ui.proxy.Proxy.html#update"><code>update</code></a> 
but takes a sequence of attributes
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.ui.proxy.Proxy.html#update">update</a></td>
    <td><span>Generic frontend function to update the contentss of a widget based
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.ui.proxy.Proxy.html#set_model">set_model</a></td>
    <td><span>Updates the model instance of the proxy.
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.ui.proxy.Proxy.html#add_widget">add_widget</a></td>
    <td><span>Adds a new widget to the proxy
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.ui.proxy.Proxy.html#remove_widget">remove_widget</a></td>
    <td><span>Removes a widget from the proxy
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.ui.proxy.Proxy.html#new_model">new_model</a></td>
    <td><span class="undocumented">Undocumented</span></td>
  </tr>
  
</table>
      
      
    </div>
    
    
    
    <div class="function">
        <a name="kiwi.ui.proxy.Proxy.__init__"></a>
        <a name="__init__"></a>
        <div class="functionHeader">
        
        def __init__(self, view, model=None, widgets=()):
        
      </div>
        <div class="functionBody">
          
          <div>Create a new Proxy object.
<table class="fieldTable"><tr class="fieldStart"><td class="fieldName">Parameters</td><td class="fieldArg">view</td><td>view attched to the slave
 (type: a <a 
href="kiwi.ui.views.BaseView.html"><code>kiwi.ui.views.BaseView</code></a> 
subclass
)</td></tr><tr><td></td><td class="fieldArg">model</td><td>model attached to proxy
</td></tr><tr><td></td><td class="fieldArg">widgets</td><td>the widget names
 (type: list of strings
)</td></tr></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.ui.proxy.Proxy._reset_widget"></a>
        <a name="_reset_widget"></a>
        <div class="functionHeader">
        
        def _reset_widget(self, attribute, widget):
        
      </div>
        <div class="functionBody">
          
          <div class="undocumented">Undocumented</div>
        </div>
      </div><div class="function">
        <a name="kiwi.ui.proxy.Proxy._setup_widget"></a>
        <a name="_setup_widget"></a>
        <div class="functionHeader">
        
        def _setup_widget(self, widget_name, widget):
        
      </div>
        <div class="functionBody">
          
          <div class="undocumented">Undocumented</div>
        </div>
      </div><div class="function">
        <a name="kiwi.ui.proxy.Proxy._register_proxy_in_model"></a>
        <a name="_register_proxy_in_model"></a>
        <div class="functionHeader">
        
        def _register_proxy_in_model(self, attribute):
        
      </div>
        <div class="functionBody">
          
          <div class="undocumented">Undocumented</div>
        </div>
      </div><div class="function">
        <a name="kiwi.ui.proxy.Proxy._unregister_proxy_in_model"></a>
        <a name="_unregister_proxy_in_model"></a>
        <div class="functionHeader">
        
        def _unregister_proxy_in_model(self):
        
      </div>
        <div class="functionBody">
          
          <div class="undocumented">Undocumented</div>
        </div>
      </div><div class="function">
        <a name="kiwi.ui.proxy.Proxy._on_widget__content_changed"></a>
        <a name="_on_widget__content_changed"></a>
        <div class="functionHeader">
        
        def _on_widget__content_changed(self, widget, attribute, validate):
        
      </div>
        <div class="functionBody">
          
          <div>This is called as soon as the content of one of the widget changes, the 
widgets tries fairly hard to not emit when it's not neccessary
<table class="fieldTable"></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.ui.proxy.Proxy._on_widget__notify"></a>
        <a name="_on_widget__notify"></a>
        <div class="functionHeader">
        
        def _on_widget__notify(self, widget, pspec):
        
      </div>
        <div class="functionBody">
          
          <div class="undocumented">Undocumented</div>
        </div>
      </div><div class="function">
        <a name="kiwi.ui.proxy.Proxy._get_model"></a>
        <a name="_get_model"></a>
        <div class="functionHeader">
        
        def _get_model(self):
        
      </div>
        <div class="functionBody">
          
          <div class="undocumented">Undocumented</div>
        </div>
      </div><div class="function">
        <a name="kiwi.ui.proxy.Proxy.proxy_updated"></a>
        <a name="proxy_updated"></a>
        <div class="functionHeader">
        
        def proxy_updated(self, widget, attribute, value):
        
      </div>
        <div class="functionBody">
          
          <div>This is a hook that is called whenever the proxy updates the model. 
Implement it in the inherited class to perform actions that should be done 
each time the user changes something in the interface. This hook by default
does nothing.
<table class="fieldTable"><tr class="fieldStart"><td class="fieldName">Parameters</td><td class="fieldArg">widget</td><td></td></tr><tr><td></td><td class="fieldArg">attribute</td><td></td></tr><tr><td></td><td class="fieldArg">value</td><td></td></tr></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.ui.proxy.Proxy.update_many"></a>
        <a name="update_many"></a>
        <div class="functionHeader">
        
        def update_many(self, attributes, value=ValueUnset, block=False):
        
      </div>
        <div class="functionBody">
          
          <div>Like <a href="kiwi.ui.proxy.Proxy.html#update"><code>update</code></a> 
but takes a sequence of attributes
<table class="fieldTable"><tr class="fieldStart"><td class="fieldName">Parameters</td><td class="fieldArg">attributes</td><td>sequence of attributes to update
</td></tr><tr><td></td><td class="fieldArg">value</td><td>see <a 
href="kiwi.ui.proxy.Proxy.html#update"><code>update</code></a>
</td></tr><tr><td></td><td class="fieldArg">block</td><td>see <a 
href="kiwi.ui.proxy.Proxy.html#update"><code>update</code></a>
</td></tr></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.ui.proxy.Proxy.update"></a>
        <a name="update"></a>
        <div class="functionHeader">
        
        def update(self, attribute, value=ValueUnset, block=False):
        
      </div>
        <div class="functionBody">
          
          <div>Generic frontend function to update the contentss of a widget based on 
its model attribute name using the internal update functions.
<table class="fieldTable"><tr class="fieldStart"><td class="fieldName">Parameters</td><td class="fieldArg">attribute</td><td>the name of the attribute whose widget we wish to updated.  If accessing
a radiobutton, specify its group name.
</td></tr><tr><td></td><td class="fieldArg">value</td><td>specifies the value to set in the widget. If unspecified, it defaults to
the current model's value (through an accessor, if it exists, or 
getattr).
</td></tr><tr><td></td><td class="fieldArg">block</td><td>defines if we are to block cascading proxy updates triggered by this 
update. You should use block if you are calling update on *the same 
attribute that is currently being updated*. This means if you have hooked 
to a signal of the widget associated to that attribute, and you call 
update() for the *same attribute*, use block=True. And pray. 8). If block 
is set to False, the normal update mechanism will occur (the model being 
updated in the end, hopefully).
</td></tr></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.ui.proxy.Proxy.set_model"></a>
        <a name="set_model"></a>
        <div class="functionHeader">
        
        def set_model(self, model, relax_type=False):
        
      </div>
        <div class="functionBody">
          
          <div>Updates the model instance of the proxy. Allows a proxy interface to 
change model without the need to destroy and recreate the UI (which would 
cause flashing, at least)
<table class="fieldTable"><tr class="fieldStart"><td class="fieldName">Parameters</td><td class="fieldArg">model</td><td></td></tr><tr><td></td><td class="fieldArg">relax_type</td><td></td></tr></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.ui.proxy.Proxy.add_widget"></a>
        <a name="add_widget"></a>
        <div class="functionHeader">
        
        def add_widget(self, name, widget):
        
      </div>
        <div class="functionBody">
          
          <div>Adds a new widget to the proxy
<table class="fieldTable"><tr class="fieldStart"><td class="fieldName">Parameters</td><td class="fieldArg">name</td><td>name of the widget
</td></tr><tr><td></td><td class="fieldArg">widget</td><td>widget, must be a gtk.Widget subclass
</td></tr></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.ui.proxy.Proxy.remove_widget"></a>
        <a name="remove_widget"></a>
        <div class="functionHeader">
        
        def remove_widget(self, name):
        
      </div>
        <div class="functionBody">
          
          <div>Removes a widget from the proxy
<table class="fieldTable"><tr class="fieldStart"><td class="fieldName">Parameters</td><td class="fieldArg">name</td><td>the name of the widget to remove
</td></tr></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.ui.proxy.Proxy.new_model"></a>
        <a name="new_model"></a>
        <div class="functionHeader">
        
        def new_model(self, model, relax_type=False):
        
      </div>
        <div class="functionBody">
          
          <div class="undocumented">Undocumented</div>
        </div>
      </div>
    
    <address>
      <a href="index.html">API Documentation</a> for Kiwi, generated by <a href="http://codespeak.net/~mwh/pydoctor/">pydoctor</a> at 2008-05-29 16:06:17.
    </address>
  </body>
</html>